<script setup>
import AirshipTypeCreate from '@/components/airship_type/AirshipTypeCreate.vue'
</script>

<template>
    <div>
        <div class="record" v-if='record != null && state=="show"'>
            <span class="record_element">name: {{record.name}} </span>
            <br/>
            <button @click='state="edit"'>Edit</button>
            <button @click="DeleteAirshipType(id)">Delete</button>
        </div>

        <AirshipTypeCreate :initial_object=record :id=id :after_post_callback='afterPostCallback' v-if='state=="edit"' />
    </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getAirshipTypeById, deleteDataBaseObject } from "../../utils/apiUtils";
import router from "../../router";

const airship_type_url = "http://127.0.0.1:8000/handlings/airship_type/";

export default {
  name: "AirshipTypeRecord",
  props: {
    id : String,
    inital_state : String
  },
  data: function() {
    return {
      record: null,
      state: "show"
    };
  },
  methods: {
    afterPostCallback() {
      this.state = "show";
    },
    DeleteAirshipType(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(airship_type_url + id + "/");
              if (response.status === 204) {
                  window.alert("airship_type deleted");
                  router.push("/airship_type");
              }
          } catch (error) {
              console.log("error: ", error);
              window.alert("cannot delete this airship type");
          }
      })();
      }
    }
  },
  mounted: function() {
    if (this.id) {
      (async () => {
          setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
          this.record = await getAirshipTypeById(this.id)
      })();
    }

    this.state = this.inital_state ? this.inital_state : this.state;
  }
};
</script>

<style scoped>
.record {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

.record_element {
  width: 100%;
  font-size: 20px;
  padding-inline: 25px;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
</style>